package usingjsp;

import javax.servlet.*;
import javax.servlet.http.*;

import java.io.*;
import java.net.*;

import java.awt.image.*;
import com.sun.image.codec.jpeg.*;

/** Receives an image uploaded using a straight HTTP POST request */

public class ReceiveImageServlet extends HttpServlet
{
    public void doPost(HttpServletRequest request,
        HttpServletResponse response)
        throws java.io.IOException, ServletException
    {
        HttpSession session = request.getSession();

        BufferedImage oldImage =
            (BufferedImage) session.getAttribute("originalImage");
        if (oldImage != null)
        {
            oldImage.flush();
        }
        
        BufferedImage currImage =
            (BufferedImage) session.getAttribute("image");
        if (currImage != oldImage)
        {
            currImage.flush();
        }
        
// Get the input stream for reading the file
        InputStream in = request.getInputStream();

// Create a decoder for JPEG data streams
        JPEGImageDecoder decoder = JPEGCodec.createJPEGDecoder(in);

// Decode the JPEG
        BufferedImage image = decoder.decodeAsBufferedImage();

// Make two copies of the image, one for the original
// and one for the modified image (it will be modified
// by other servlets)
        session.setAttribute("originalImage", image);
        session.setAttribute("image", image);

// Go to the image menu
        response.sendRedirect(
            "/jspbook/ch27/examples/ImageMenu.jsp?url="+
            URLEncoder.encode(
                "/servlet/usingjsp.ShowOriginalImageServlet"));
    }
}
