package usingjsp;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

public class ShowParametersServlet extends HttpServlet
{
	public void service(HttpServletRequest request,
		HttpServletResponse response)
		throws IOException
	{
// Tell the web server that the response is HTML
		response.setContentType("text/html");		

		PrintWriter out = response.getWriter();

		out.println("<HTML>");
		out.println("<BODY>");
		out.println("You passed me the following parameters:");
		out.println("<PRE>");

// Find out the names of all the parameters
		Enumeration params = request.getParameterNames();

		while (params.hasMoreElements())
		{
// Get the next parameter name
			String paramName = (String) params.nextElement();

// Use getParameterValues in case there are multiple values
			String paramValues[] = 
				request.getParameterValues(paramName);
		
// If there is only one value, print it out
			if (paramValues.length == 1)
			{
				out.println(paramName+
					"="+paramValues[0]);
			}
			else
			{
// For multiple values, loop through them
				out.print(paramName+"=");

				for (int i=0; i < paramValues.length; i++)
				{
// If this isn't the first value, print a comma to separate values
					if (i > 0) out.print(',');

					out.print(paramValues[i]);
				}
				out.println();
			}
		}

		out.println("</PRE>");
		out.println("</BODY>");
		out.println("</HTML>");
	}
}
