package usingjsp;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

public class ReceiveUploadServlet extends GenericServlet
{
    public void service(ServletRequest request,
        ServletResponse response)
        throws IOException
    {
// Get the content type
        String contentType = request.getContentType();

// Set a default for the boundary string length
// Find out where the boundary string starts
        int boundaryIndex = contentType.indexOf("boundary=");

// Get the boundary string
        String boundary = contentType.substring(boundaryIndex+9);
        int boundaryStrLength = boundary.length();

// Get the input stream to read the uploaded file
        ServletInputStream servIn = request.getInputStream();

        DataInputStream in = new DataInputStream(servIn);

// Lop off the headers from the content (read until you get a blank line)
        String line;

        while ((line = in.readLine()) != null)
        {
            getServletContext().log("Got line: "+line);
            if (line.trim().length() == 0) break;
        }

        ByteArrayOutputStream byteOut = new ByteArrayOutputStream(
            request.getContentLength());

        byte[] buffer = new byte[4096];
        int len;

// Copy the uploaded file to a byte array
        while ((len = in.read(buffer)) > 0)
        {
            byteOut.write(buffer, 0, len);
        }

        byte[] outBytes = byteOut.toByteArray();

        FileOutputStream fileOut = new FileOutputStream("uploaded_file");

// Write the byte array out the the file, trim off the boundary plus some
// padding surrounding the boundary
        fileOut.write(outBytes, 0, outBytes.length - boundaryStrLength - 8);
        fileOut.close();

// Tell the web server that the response is HTML
        response.setContentType("text/html");

// Get the PrintWriter for writing out the response
        PrintWriter out = response.getWriter();

// Write the HTML back to the browser
        out.println("<HTML>");
        out.println("<BODY>");

        String clientHost = request.getRemoteHost();

        out.println("File Accepted, thank you.");

        out.println("</BODY>");
        out.println("</HTML>");
    }
}
