package usingjsp.problemreport;

import usingjsp.DatabaseObject;
import java.sql.*;

/** A data object representing a developer in the problem reporting
 *  system.
 */
public class Developer extends DatabaseObject
    implements java.io.Serializable
{
    public String developer;
    public String userName;
    public String password;

    public Developer()
    {
    }

    public Developer(ResultSet results)
        throws SQLException
    {
        developer = results.getString("developer");
        userName = results.getString("userName");
        password = results.getString("pword");
    }

    public String getDeveloper() { return developer; }
    public void setDeveloper(String aDeveloper)
        { developer = aDeveloper; }

    public String getUserName() { return userName; }
    public void setUserName(String aUserName)
        { userName = aUserName; }

    public String getPassword() { return password; }
    public void setPassword(String aPassword)
        { password = aPassword; }
    
    public String getTableName() { return "developer"; }

    public DatabaseObject createInstance(ResultSet results)
        throws SQLException
    {
        return new Developer(results);
    }

    public String getFieldList() { return "developer,username,pword"; }

    public String getInsertStatement()
    {
        return "insert into developer (developer, username, pword) "+
            " values (?,?,?)";
    }

    public void prepareInsertStatement(PreparedStatement s)
        throws SQLException
    {
        s.setString(1, developer);
        s.setString(2, userName);
        s.setString(3, password);
    }

    public String getUpdateStatement()
    {
        return "update developer set developer=?, pword=? "+
            " where username=?";
    }

    public void prepareUpdateStatement(PreparedStatement s)
        throws SQLException
    {
        s.setString(1, developer);
        s.setString(2, password);
        s.setString(3, userName);
    }

    public String getDeleteStatement()
    {
        return "delete from developer where username=?";
    }

    public void prepareDeleteStatement(PreparedStatement s)
        throws SQLException
    {
        s.setString(1, userName);
    }
}
