package usingjsp.cart;

import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;
import usingjsp.cart.corba.*;

public class ShoppingCartFactoryImpl extends _IShoppingCartFactoryImplBase
{
    static ORB orb;

    public ShoppingCartFactoryImpl()
    {
    }

/** Creates a new shopping cart */
    public IShoppingCart createShoppingCart()
    {
        IShoppingCart cart = new ShoppingCartImpl();

        orb.connect(cart);

        return cart;
    }

    public static void main(String[] args)
    {
        String factoryService = System.getProperty("service",
            "ShoppingCartFactory");
        try
        {
// Create a reference to the CORBA orb
            orb = ORB.init(args, null);

// Create an instance of the MOTD implementation
            ShoppingCartFactoryImpl impl =
                new ShoppingCartFactoryImpl();

// Register the MOTD implementation with the ORB
            orb.connect(impl);
            
// Locate the CORBA naming service
            org.omg.CORBA.Object objRef =
                orb.resolve_initial_references("NameService");
               
// Cast the CORBA Object to NamingContext using the narrow method
            NamingContext ncRef = NamingContextHelper.narrow(objRef);

// Create a NameComponent representing the path for the MOTD service
            NameComponent nc = new NameComponent(factoryService, "");
            NameComponent[] path = new NameComponent[] { nc };

// Register the shopping cart factory implementation 
            ncRef.rebind(path, impl);

// Go into an infinite loop while the ORB services requests
            java.lang.Object sync = new java.lang.Object();
            synchronized (sync)
            {
                sync.wait();
            }
        }
        catch (Exception exc)
        {
            exc.printStackTrace();
        }
    }
}
