package usingjsp.motd;

import org.omg.CORBA.*;
import org.omg.CosNaming.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

public class ShowMOTDServlet extends HttpServlet
{
    public void service(HttpServletRequest request,
        HttpServletResponse response)
        throws IOException, ServletException
    {
        try
        {
            MOTD motd = (MOTD) getServletContext().getAttribute("MOTD");

            String motdMessage = motd.getMOTD();

            response.setContentType("text/html");

            PrintWriter out = response.getWriter();
        
            out.println("<html><body bgcolor=\"#ffffff\">");
            out.println("<table><tr><td bgcolor=\"#000080\">");
            out.println("<font color=\"#ffffff\">");
            out.println(motdMessage);
            out.println(" </font></table><h1>Welcome</h1>");
            out.println("Welcome to the Site");
            out.println("</body></html>");
        }
        catch (Exception exc)
        {
            throw new ServletException("Got exception: "+exc.toString());
        }
    }

    public void init()
    {
        try
        {
// Create an instance of the CORBA orb
            ORB orb = ORB.init(
                new String[] { "-ORBInitialPort", "1050" }
                , null);

// Locate the CORBA naming service
            org.omg.CORBA.Object objRef =
                orb.resolve_initial_references("NameService");

// Instead of using the Java cast operator, the correct way to convert
// a CORBA Object into a specific type is to use that type's helper
            NamingContext ncRef = NamingContextHelper.narrow(objRef);

// Create a name component path for locating the MOTD service
            NameComponent nc = new NameComponent("MessageOfTheDay", "");
            NameComponent path[] = new NameComponent[] { nc };

// Locate the MOTD service and narrow (i.e. cast) the reference 
// to an object of type MOTD
            MOTD motdRef = MOTDHelper.narrow(ncRef.resolve(path));
            
// Put the MOTD object in the application object
            getServletContext().setAttribute("MOTD", motdRef);
        }
        catch (Exception exc)
        {
            getServletContext().log("Error binding to MOTD service", exc);
        }
    }
}
