package usingjsp.scores;

import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;
import usingjsp.*;

public class ScoreSupport
{
    public static IConnectionPool getConnectionPool(
        ServletContext application)
        throws SQLException
    {
        IConnectionPool pool =
            (IConnectionPool) application.getAttribute(
                "ScoresConnectionPool");
        
        if (pool == null)
        {
            synchronized (application)
            {
                pool = (IConnectionPool) application.getAttribute(
                        "ScoresConnectionPool");
                if (pool == null)
                {
                    try
                    {
                        Class.forName("org.gjt.mm.mysql.Driver").
                            newInstance();
                    }
                    catch (Exception exc)
                    {
                        application.log("Error loading JDBC driver", exc);
                    }

                    pool = new ConnectionPool(
                        "jdbc:mysql://localhost/usingjsp", "", "", 3);

                    application.setAttribute("ScoresConnectionPool",
                        pool);
                }
            }
        }

        return pool;
    }

    public static boolean isWML(HttpServletRequest request)
    {
        String accept = request.getHeader("Accept");
        if (accept == null) return false;

        if (accept.indexOf("text/vnd.wap.wml") >= 0)
        {
            return true;
        }

        return false;
    }
}
