package usingjsp.scores;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.sql.*;
import java.util.*;

import usingjsp.*;

public class ShowRecordsServlet extends HttpServlet
{
    public void service(HttpServletRequest request,
        HttpServletResponse response)
        throws IOException, ServletException
    {
        Connection conn = null;
        IConnectionPool pool = null;

        try
        {
            pool = ScoreSupport.getConnectionPool(getServletContext());
            
            conn = pool.getConnection();

            Score query = new Score();

// Get all the scores
            Vector v = query.getAll(conn);

// Create a table to keep track of each player
            Hashtable playerRecords = new Hashtable();

            Enumeration e = v.elements();

            while (e.hasMoreElements())
            {
                Score s = (Score) e.nextElement();

// Get the player's wins, losses and cumulative spread
                int[] playerRecord = (int[]) playerRecords.get(
                    s.player);

// If this player isn't in the table, create a blank entry
                if (playerRecord == null)
                {
                    playerRecord = new int[] { 0, 0, 0 };
                    playerRecords.put(s.player, playerRecord);
                }

// If the player won this game, increment the wins
                if (s.playerScore > s.opponentScore)
                {
                    playerRecord[0]++;
                }
                else
                {
// Otherwise increment the losses (a bug here: a tie shows up as a loss)
                    playerRecord[1]++;
                }
// Update the cumulative spread
                playerRecord[2] += (s.playerScore - s.opponentScore);
            }

// Put the table in the request so the JSP can get at it
            request.setAttribute("recordTable", playerRecords);

            String destPage = "/ShowRecordsHTML.jsp";

            if (ScoreSupport.isWML(request))
            {
                destPage = "/ShowRecordsWML.jsp";
            }

            getServletContext().getRequestDispatcher(destPage).forward(
                request, response);
        }
        catch (Exception exc)
        {
            String errorPage = "/ErrorHTML.jsp";

            if (ScoreSupport.isWML(request))
            {
                errorPage = "/ErrorWML.jsp";
            }

            request.setAttribute("exception", exc);

            exc.printStackTrace();

            getServletContext().getRequestDispatcher(errorPage).forward(
                request, response);
        }
        finally
        {
            if (conn != null)
            {
                try
                {
                    pool.releaseConnection(conn);
                } catch (Exception ignore) {}
            }
        }
    }
}
