package usingjsp.scores;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.sql.*;
import java.util.*;

import usingjsp.*;

public class ShowScoresServlet extends HttpServlet
{
    public void service(HttpServletRequest request,
        HttpServletResponse response)
        throws IOException, ServletException
    {
        Connection conn = null;
        IConnectionPool pool = null;

// See if there is a specific player whose scores should be shown
        String whichPlayer = request.getParameter("player");
        
        try
        {
            pool = ScoreSupport.getConnectionPool(getServletContext());
            
            conn = pool.getConnection();

            Score query = new Score();

// By default, use a dummy where clause that would retrieve all scores
            String whereClause = "round > 0";

// If the query should search for a specific player, change the where clause
            if (whichPlayer != null)
            {
                whereClause = "player = '"+whichPlayer+"'";
            }

// Do the query and add an "order by" clause to make display easier
            Vector v = query.getAll(conn,
                whereClause + " order by round, player");

// Put the list in the request so the JSP can get at it
            request.setAttribute("scoreList", v);

            String destPage = "/ShowScoresHTML.jsp";

            if (ScoreSupport.isWML(request))
            {
                destPage = "/ShowScoresWML.jsp";
            }

            getServletContext().getRequestDispatcher(destPage).forward(
                request, response);
        }
        catch (Exception exc)
        {
            String errorPage = "/ErrorHTML.jsp";

            if (ScoreSupport.isWML(request))
            {
                errorPage = "/ErrorWML.jsp";
            }

            request.setAttribute("exception", exc);

            exc.printStackTrace();

            getServletContext().getRequestDispatcher(errorPage).forward(
                request, response);
        }
        finally
        {
            if (conn != null)
            {
                try
                {
                    pool.releaseConnection(conn);
                } catch (Exception ignore) {}
            }
        }
    }
}
