import javax.servlet.jsp.tagext.*;
import javax.servlet.jsp.*;
import java.io.*;

public class CheckerboardTag extends TagSupport
{
// Variables to hold the attributes for the checkerboard

    protected int width = 40;
    protected int height = 40;
    protected int rows = 8;
    protected int cols = 8;
    protected String darkColor = "#000040";
    protected String lightColor = "#FFFFC0";

    public int doStartTag()
        throws JspException
    {
        try
        {
            JspWriter out = pageContext.getOut();

            out.println("<table>");

// Count down so the bottom row is row 0 (it helps for
// calculating the colors, the bottom left should be dark)

            for (int i=rows-1; i >= 0; i--)
            {
// Start a new row with the specified height
                out.print("<tr height=\""+height+"\">");

// Loop through the columns
                for (int j=0; j < cols; j++)
                {

// Start making the cell for this square
                    out.print("<td width=\""+width+"\" bgcolor=\"");

// If row+column is even, make the square dark. The lower-left
// corner should always be dark

                    if ((i + j) % 2 == 0)
                    {
                        out.print(darkColor);
                    }
                    else
                    {
                        out.print(lightColor);
                    }
                    out.print("\">&nbsp;</td>");
                }
                out.println("</tr>");
            }
            out.println("</table>");
        }
        catch (IOException ioExc)
        {
            throw new JspException(ioExc.toString());
        }

        return SKIP_BODY;
    }

    public int doEndTag()
    {
        return EVAL_PAGE;
    }

// Get/set methods, just like in a bean

    public int getHeight() { return height; }
    public void setHeight(int aHeight) { height = aHeight; }

    public int getWidth() { return width; }
    public void setWidth(int aWidth) { width = aWidth; }

    public int getRows() { return rows; }
    public void setRows(int aRows) { rows = aRows; }

    public int getCols() { return cols; }
    public void setCols(int aCols) { cols = aCols; }

    public String getDarkColor() { return darkColor; }
    public void setDarkColor(String aDarkColor)
    {
        darkColor = aDarkColor;
    }

    public String getLightColor() { return lightColor; }
    public void setLightColor(String aLightColor)
    {
        lightColor = aLightColor;
    }
}
